<template>
  <v-app>
    <main>
      <v-container fill-height>
        <v-layout row wrap align-center>
          <v-flex sm4 offset-sm4>
            <v-card>
              <v-card-title primary-title>
                <div class="text-xs-center">
                  <div class="display-3 fw-300">Dayo</div>
                  <span class="deep-orange--text text--darken-3">Your Game. Your Time</span>
                </div>
              </v-card-title>
              <v-alert error :value="error">{{error}}</v-alert>
              <v-form method="post" @submit.prevent="login" ref="loginForm">
                <v-card-text>
                  <v-text-field label="Email" v-model="account['email']" :rules="[$rules.required, $rules.email]" required></v-text-field>
                  <v-text-field label="Password" type="password" v-model="account['password']" :rules="[$rules.required]" required></v-text-field>
                </v-card-text>
                <v-divider></v-divider>
                <v-card-actions>
                  <v-btn flat primary type="submit" :loading="loggingIn">Login</v-btn>
                  <v-btn flat to="/signup" class="grey--text text--darken-2">Signup</v-btn>
                </v-card-actions>
              </v-form>
            </v-card>
            <div class="mt-4 text-sm-center grey--text">
              <p class="mb-0">Login via</p>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Facebook' }" @click="connectSocial('facebook')">
                <img src="../assets/social-media-icons/003-facebook.png" alt="">
              </v-btn>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Twitter' }" @click="connectSocial('twitter')">
                <img src="../assets/social-media-icons/002-twitter.png" alt="">
              </v-btn>
              <v-btn icon dark v-tooltip:bottom="{ html: 'Google+' }" @click="connectSocial('gplus')">
                <img src="../assets/social-media-icons/001-gplus.png" alt="">
              </v-btn>
            </div>
          </v-flex>
        </v-layout>
      </v-container>
    </main>
  </v-app>
</template>

<script>
  import firebase from 'firebase'
  export default {
    name: 'login',
    data () {
      return {
        account: {},
        error: null,
        loggingIn: false
      }
    },
    methods: {
      connectSocial (type) {
        let provider = firebase.auth

        switch (type) {
          case 'facebook':
            provider = new provider.FacebookAuthProvider()
            break
          case 'gplus':
            provider = new provider.GoogleAuthProvider()
            break
          case 'twitter':
            provider = new provider.TwitterAuthProvider()
            break
        }

        firebase.auth().signInWithPopup(provider).then(({user}) => {
          this.$database.ref(`users/${user.uid}`).once('value').then(snapshot => {
            let exist = snapshot.val()

            if (!exist) {
              this.uid = user.uid
              this.user = {
                fullName: user.displayName,
                email: user.email,
                contact: user.phoneNumber,
                photo: user.photoURL
              }

              this.$router.push({
                name: 'signup',
                params: {
                  uid: this.uid,
                  user: this.user
                }
              })
            } else {
              this.$store.commit('setState', {
                authenticated: true,
                user: user.toJSON()
              })
              this.$router.push({path: this.$route.params.ref || '/'})
            }
          })
        }).catch(error => {
          this.error = error.message
          console.log(error.code)
        })
      },
      login () {
        if (this.$refs.loginForm.validate()) {
          this.loggingIn = true
          this.error = null
          firebase.auth().signInWithEmailAndPassword(this.account.email, this.account.password).then(authUser => {
            this.$database.ref(`users/${authUser.uid}`).once('value').then(snapshot => {
              let user = snapshot.val()

              if (user.role === 'merchant') {
                this.$store.commit('setState', {
                  authenticated: true,
                  user: authUser.toJSON()
                })

                this.loggingIn = false
                this.$router.push({path: this.$route.params.ref || '/'})
              } else {
                firebase.auth().signOut().then(() => {
                  this.error = `You're not using a merchant account.`
                  this.loggingIn = false
                })
              }
            })
          }).catch(error => {
            this.loggingIn = false
            this.error = error.message
            console.log(error.code)
          })
        }
      }
    }
  }
</script>

<style scoped lang="stylus">
  @require '../../node_modules/vuetify/src/stylus/settings/_colors'

  .card__title div {
    width: 100%;
    color: $deep-orange.darken-3;
  }
</style>
